flask1/routes.py
# coding=utf-8
from flask import current_app, Blueprint, request, make_response, render_template, redirect, url_for
from flask_login import login_required, login_user, logout_user
import datetime

from flask1.db import get_db
from flask1.login import User, loginUserPass, logoutUser
from .models import *
from .csvexport import CsvExporter
from .alarmas import check_alarma, check_alarmas
from sqlalchemy import or_

bp = Blueprint('main', __name__, url_prefix='')

def checkparams(form, musthave):
    if len(form) < len(musthave):
        raise Exception('Pocos parámetros enviados ({}<{})'.format(len(form), len(musthave)))
    for v in musthave:
        if v not in form:
            raise Exception('Falta el parámetro "{}"'.format(v))


########################### ERRORES/LOGIN/OUT/INDEX
@bp.app_errorhandler(500)
def server_error(e):
    #404-error-handling https://www.geeksforgeeks.org/python-404-error-handling-in-flask/
    print(e)
    return render_template("500.html",url=request.path)

@bp.app_errorhandler(404)
def not_found(e):
    return render_template("404.html",url=request.path)

@bp.route("/login", methods=["GET", "POST"])
def login():
    if request.method == 'GET':
        return render_template('login.html')
    else:
        try: checkparams(request.form, ('user', 'password'))
        except Exception as e: return str(e), 400

        if loginUserPass(request.form['user'], request.form['password']):
            return redirect(request.args.get('next') or url_for('main.index'))
        else:
            return "Credenciales inválidas", 400

@bp.route("/logout")
@login_required
def logout():
    logoutUser()
    return redirect(url_for('main.login'))

@bp.route("/")
@login_required
def index():
    r = make_response(render_template(
        'index.html'
    ))
    return r

flask1/templates/__base.html
<!-- Templating Essentials - https://code.tutsplus.com/tutorials/templating-with-jinja2-in-flask-essentials--cms-25571 -->
<!-- Bootstrap themes, templates, and more - https://startbootstrap.com/ -->
<!-- Bootstrap Components - https://v4-alpha.getbootstrap.com/components/alerts/ -->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Sou</title>

    <link href="{{ url_for('static', filename='css/bootstrap4.min.css' ) }}" rel="stylesheet">
    {% block head %}{% endblock %}
</head>
<body>
    <script src="{{ url_for('static' , filename='js/jquery3.min.js' ) }}" type="text/javascript"></script>
    <script src="{{ url_for('static' , filename='js/bootstrap4.min.js' ) }}" type="text/javascript"></script>
    {% block body %}{% endblock %}
</body>
</html>

flask1/templates/_form.html
{% macro form(method='POST') -%}
<form novalidate method="{{method}}">
    <div class="alert alert-danger fade show" style="display: none;">
        <p class="mb-0"></p>
    </div>
    <div class="alert alert-warning fade show" style="display: none;">
        <p class="mb-0"></p>
    </div>
    <div class="alert alert-success fade show" style="display: none;">
        <p class="mb-0">Operación realizada</p>
    </div>
    {{ caller() }}
</form>
{%- endmacro %}

{% macro card(title, size=12, method='POST', css_class='', icon='') -%}
<div class="col-lg-{{size}} {{css_class}}">
    <div class="card card-body bg-light">
        <h3 class="card-header">{{icon|safe}}{{title}}</h3>
        <div class="card-block">
            <form novalidate method="{{method}}">
                <div class="alert alert-danger fade show" style="display: none;">
                    <p class="mb-0"></p>
                </div>
                <div class="alert alert-warning fade show" style="display: none;">
                    <p class="mb-0"></p>
                </div>
                <div class="alert alert-success fade show" style="display: none;">
                    <p class="mb-0">Operación realizada</p>
                </div>
                {{ caller() }}
            </form>
        </div>
    </div>
</div>
{%- endmacro %}

{% macro cardNoForm(title, size=12, css_class='') -%}
<div class="col-lg-{{size}} {{css_class}}">
    <div class="card card-body bg-light">
        <h3 class="card-header">{{title}}</h3>
        <div class="card-block">
            {{ caller() }}
        </div>
    </div>
</div>
{%- endmacro %}

{% macro dataToJsArr(arr, idattr='id', txtattr='nombre') -%}
[
    {% for i in arr %}
        {
            "id": {{i[idattr]}},
            "text": "{{i[txtattr]}}"
        }
        {% if not loop.last %},{% endif %}
    {% endfor %}
]
{%- endmacro %}

{% macro dataToJsArrMulti(arr, txtattr1, txtattr2, idattr='id') -%}
[
    {% for i in arr %}
        {
            "id": {{i[idattr]}},
            "text": "{{i[txtattr1]}} - {{i[txtattr2]}}"
        }
        {% if not loop.last %},{% endif %}
    {% endfor %}
]
{%- endmacro %}


{% macro input_number(col, name, min=0, required=False, readonly=False, value='') -%}
{% set requiredTag = 'required ' if required else '' %}
{% set readOnlyTag = 'readonly ' if readonly else '' %}
{% set valueTag = 'value='+value|string+' ' if value else '' %}
<div class="col-sm-{{col}}">
	<input type="number" name="{{name}}" class="form-control" placeholder="#" min="{{min}}" max="9999"{{requiredTag}}{{readOnlyTag}}{{valueTag}}>
</div>
{%- endmacro %} 

{% macro input_select(col, name, errmsg, required=0, class='') -%}
{% set requiredTag = 'required ' if required else '' %}
{% set classTag = ' '+class if class else '' %}
<div class="col-sm-{{col}}">
    <select class="form-control select2-single select2-hidden-accessible{{classTag}}" name="{{name}}"{{requiredTag}}>
        <option></option>
    </select>
    <div class="invalid-feedback">{{errmsg}}</div>
</div>
{%- endmacro %} 

{% macro input_msg(col, msg, css_class='') -%}
<div class="col-sm-{{col}} {{css_class}}">
    <p class="my-2 ml-2">{{ msg }}</p>
</div>
{%- endmacro %} 

flask1/templates/_maingui.html
{% extends '__base.html' %}
{% import '_form.html' as forms %}

{% block head %}
<link href="{{ url_for('static', filename='css/select2.min.css' ) }}" rel="stylesheet" />
<link href="{{ url_for('static', filename='css/select2mod.css' ) }}" rel="stylesheet" />
<link href="{{ url_for('static', filename='css/sidebar.css' ) }}" rel="stylesheet" />
<link href="{{ url_for('static', filename='css/bootstrap-datepicker3.min.css' ) }}" rel="stylesheet" />
<style>
	html {background-color: #555;}
    .wrapper{
        background-image: url('{{ url_for('static', filename='bgimg/cogobgform'+ range(1, 4) | random | string +'.jpg' ) }}');
        background-repeat: repeat-y;
        background-size: cover;
        background-color: #9007dd;
    }
    .card-block form { padding-top: 10px; }
</style>
{% block styles %}{% endblock %}
{% endblock %}

{% block body %}
<!-- Bootstrap Sidebar https://bootstrapious.com/p/bootstrap-sidebar -->
<div class="wrapper">
    <!-- Sidebar -->
    <nav id="sidebar">
      <div class="sidebar-header" style="color: #ffff01;font-weight: bold;">
        <a href="/">
          <h3>Cogonauts Sys</h3>
        </a>
      </div>
      <ul class="list-unstyled components">
         <!-- <p>Menú</p> -->
        {% include '_menu.html' %}
      </ul>
    </nav>

    <!-- Main -->
    <div id="content">
        <!-- Top bar -->
       <!--  <nav class="navbar navbar-expand-lg navbar-light bg-light">
            <div class="container-fluid">
                <button type="button" id="sidebarCollapse" class="btn btn-info">
                    <i class="fas fa-align-left"></i>
                    <span>Mostrar/ocultar menú</span>
                </button>
            </div>
        </nav> -->
        <!-- Content -->
        <div class="container pt-3">
            <div class="row content">
                {% block content %}{% endblock %}
            </div>
        </div>
    </div>
</div>

<!-- Menu Toggle Script -->
<script>
$(function() {
    $('#sidebarCollapse').on('click', function () {
        $('#sidebar').toggleClass('active');
    });
    //mio
    $('.dropdown-toggle').click(function () {
        $('.dropdown-toggle[aria-expanded="true"]').next().collapse('hide');
    });
});
</script>
<script src="{{ url_for('static', filename='js/select2.min.js' ) }}" type="text/javascript"></script>
<script src="{{ url_for('static', filename='js/bootstrap-datepicker.min.js' ) }}" type="text/javascript"></script>
<script src="{{ url_for('static', filename='js/bootstrap-datepicker.es.min.js' ) }}" type="text/javascript"></script>
<script src="{{ url_for('static', filename='js/common_forms.js' ) }}" type="text/javascript"></script>
<!-- <script src="{{ url_for('static', filename='js/jquery.validate.min.js' ) }}" type="text/javascript"></script> -->
{% block js %}{% endblock %}
{% endblock %}

flask1/templates/_menu.html
{% set menus = [
	{'name': 'prioridades', 'tit': 'Prioridades impresión', 'submenus': [
		{'endp': 'menu_prioridadimpresion', 'tit': 'Prioridad impresión'},
        {'endp': 'menu_factoresdeimpresion', 'tit': 'Factores de impresión', 'admin': 1},
	]},
	{'name': 'pikas', 'tit': 'Pikas', 'submenus': [
        {'endp': 'menu_ingresarprestock', 'tit': 'Ingresar prestock'},
        {'endp': 'menu_armadopika', 'tit': 'Ingresar stock'},
        {'endp': 'menu_stockpikas', 'tit': 'Stocks'},
        {'endp': 'menu_graficostock', 'tit': 'Gráfico stock'},
        {'endp': 'menu_agregelimpika', 'tit': 'Agregar/elim. pika', 'admin': 1},
        {'endp': 'menu_modificarstockpika', 'tit': 'Modificar stock', 'admin': 1},
        {'endp': 'menu_modificarcolorpikas', 'tit': 'Modificar colores stock', 'admin': 1},
	]},
	{'name': 'insumos', 'tit': 'Insumos', 'submenus': [
        {'endp': 'menu_ingresarinsumo', 'tit': 'Ingresar insumos'},
        {'endp': 'menu_rolloplaabierto', 'tit': 'Rollo PLA abierto'},
        {'endp': 'menu_insumoabierto', 'tit': 'Insumo abierto'},
        {'endp': 'menu_stockinsumos', 'tit': 'Stock'},
        {'endp': 'menu_stockextendidoinsumos', 'tit': 'Stock Extendido'},
        {'endp': 'menu_movimientosstock', 'tit': 'Movimientos Stock'},
        {'endp': 'menu_agregeliminsu', 'tit': 'Agregar/elim. insumo', 'admin': 1},
        {'endp': 'menu_asociarinsumospika', 'tit': 'Asociar insumos a pika', 'admin': 1},
        {'endp': 'menu_listadoinsumospikas', 'tit': 'Listado asociaciones', 'admin': 1},
        {'endp': 'menu_modificarstockinsu', 'tit': 'Modificar stock', 'admin': 1},
		{'endp': 'menu_listadoeditable', 'tit': 'Listado editable', 'admin': 1},
	]},
	{'name': 'ventas', 'tit': 'Ventas', 'submenus': [
        {'endp': 'menu_ingresarpedido', 'tit': 'Ingresar pedido'},
        {'endp': 'menu_listadoventas', 'tit': 'Listado'},
        {'endp': 'menu_agregelimtipoventa', 'tit': 'Agregar/elim. tipo venta', 'admin': 1},
        {'endp': 'menu_eliminarventa', 'tit': 'Eliminar venta', 'admin': 1},
	]},
	{'name': 'fallas', 'tit': 'Fallas', 'submenus': [
        {'endp': 'menu_ingresarfalla', 'tit': 'Ingresar falla'},
        {'endp': 'menu_listadofallas', 'tit': 'Listado'},
        {'endp': 'menu_agregelimgcode', 'tit': 'Agregar/elim. g-code', 'admin': 1},
        {'endp': 'menu_agregelimmaquina', 'tit': 'Agregar/elim. máquina', 'admin': 1},
	]},
	{'name': 'alarmas', 'tit': 'Alarmas', 'submenus': [
        {'endp': 'menu_listadoalarmas', 'tit': 'Listado alarmas'},
        {'endp': 'menu_agregelimalarma', 'tit': 'Agregar/elim. alarma', 'admin': 1},
	]}
] %}
{% for menu in menus %}
<li>
    <a href="#{{menu.name}}Submenu" data-toggle="collapse" aria-expanded="false" class="dropdown-toggle">{{menu.tit}}</a>
	<ul class="collapse list-unstyled" id="{{menu.name}}Submenu">
	{% for submenu in menu.submenus %}
		{% set endp_url = url_for(menu.name + '.' + submenu.endp) %}
		{% if submenu.get('admin') %}
			{% if current_user.isadmin %}
	        <li><a href="{{endp_url}}">[{{submenu.tit}}]</a></li>
			{% endif %}
		{% else %}
        <li><a href="{{endp_url}}">{{submenu.tit}}</a></li>
		{% endif %}
	{% endfor %}
	</ul>
</li>
{% endfor %}

<li onclick="if (confirm('¿Está seguro que desea salir?')) window.location.href = '{{url_for('main.logout')}}';"><a href="#" style="font-size: 0.8rem;">
    CERRAR SESIÓN
</a></li>

flask1/templates/index.html
{% extends '_maingui.html' %}

{% block content %}

{% endblock %}

flask1/templates/login.html
{% extends '__base.html' %}

{% block head %}
<link href="{{ url_for('static', filename='css/fontawesome5all.css' ) }}" rel="stylesheet">
<style type="text/css">
    body{
        background-image: url('{{ url_for('static', filename='bgimg/cogobglogin.jpg' ) }}');
        background-repeat: repeat-y;
        background-size: cover;
        background-color: #9007dd;
    }

    .login-form {
        width: 340px;
        margin: 50px auto;
    }
    .login-form form {
        margin-bottom: 15px;
        background: #f7f7f7;
        box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
        padding: 30px;
    }
    .login-form h2 {
        margin: 0 0 15px;
    }
    .form-control, .btn {
        min-height: 38px;
        border-radius: 2px;
    }
    .btn {
        font-size: 15px;
        font-weight: bold;
    }
</style>
{% endblock %}


{% block body %}
<!-- https://www.tutorialrepublic.com/codelab.php?topic=bootstrap&file=simple-login-form -->
<!-- https://bootsnipp.com/snippets/j6r4X -->
<div class="login-form">
    <form novalidate action="" method="post">
        <h2 class="text-center">Ingreso</h2>
        <div class="alert alert-danger fade show" style="display: none;">
            <p class="mb-0"></p>
        </div>
        <!-- USUARIO -->
        <div class="form-group">
            <div class="input-group">
                <div class="input-group-prepend">
                    <span class="input-group-text"> <i class="fa fa-user"></i> </span>
                 </div>
                <input type="text" class="form-control" name="user" placeholder="Usuario" required="required">
             </div>
        </div>
        <!-- CONTRA -->
        <div class="form-group">
            <div class="input-group">
                <div class="input-group-prepend">
                    <span class="input-group-text"> <i class="fa fa-lock"></i> </span>
                 </div>
                <input type="password" class="form-control" name="password" placeholder="Contraseña" required="required" \>
            </div>
        </div>
        <!-- BOTON -->
        <div class="form-group">
            <button type="submit" class="btn btn-primary btn-block">Entrar</button>
        </div>
        <!-- <div class="clearfix">
            <label class="pull-left checkbox-inline"><input type="checkbox"> Remember me</label>
            <a href="#" class="pull-right">Forgot Password?</a>
        </div> -->
    </form>
    <!-- <p class="text-center"><a href="#">Create an Account</a></p> -->
</div>

<script src="{{ url_for('static', filename='js/common_forms.js' ) }}" type="text/javascript"></script>
<script type="text/javascript">
$(function() {
    $('.login-form input').keypress(function(e){
        if (e.keyCode == 13) $('.login-form button').click()
    })

    regFormValid(true, function(){
        params = window.location.href.split('next=');
        window.location.href = window.location.origin + decodeURIComponent(params[1] || '')
    });

    //si submiteo bien borrar validaciones
    document.forms[0].addEventListener('submit', function(event) {
        console.log(event, this)
        if (!event.cancelBubble)
            this.classList.remove('was-validated');
    })
});
</script>
{% endblock %}